/** Copyright AZS Services 2002-2004 http://www.a2zss.com */
package com.a2zss.ISO8583.samples;

import com.a2zss.ISO8583.*;

public class coralpaysample {
	
	
	public static void main(String[] args) {	

	Config conf=new Config();
	ISO8583II isosdk=new ISO8583II(conf);

	isosdk.setDebuglevel(3);
	isosdk.setOutput(System.out);
		
	int n=10; // number of cycles to test performance
	try { if (args!=null) n=Integer.valueOf(args[0]).intValue();
	    } catch (Exception exl) { n=10;}
	
	long start=System.currentTimeMillis();
	for(int j=0; j<n; j++)
	{

	// building iso message as follows:
	Message message=new Message(); // this an empty message
	//5.1.2.2 Credit Card Financial Request Format (0100/0200)
	
	 ISOField mti=new ISOField(ISOField.F_MTI, "1110", 1, conf);
	 message.putISOField(mti);
	 Bitmap b0=new Bitmap(ISOField.F0_BITMAP0, conf);
	 message.putISOField(b0); // primary bitmap
	
	 Bitmap b1=new Bitmap(ISOField.F1_BITMAP1, conf);
	 b0.setBit(ISOField.F1_BITMAP1, true);
	 message.putISOField(b1); //secondary bitmap
	 
	     
     ISOField stan=new ISOField(ISOField.F11_STAN, ""+j, 1, conf); // system audit number
     b0.setBit(ISOField.F11_STAN, true);
     message.putISOField(stan);

     ISOField respc=new ISOField(ISOField.F39_ACTION_CODE, "000", 1, conf); // response action code
     b0.setBit(ISOField.F39_ACTION_CODE, true);
     message.putISOField(respc);

		// customize field 41 to n8 default is an 8
	conf.setCustomMaxLength(ISOField.F41_TERMINAL_ID,1,8); 
	conf.setCustomType(ISOField.F41_TERMINAL_ID, 1, Type.NUMBER); // default an
     	ISOField cati=new ISOField(ISOField.F41_TERMINAL_ID, "12345678", 1, conf); // 
       	b0.setBit(ISOField.F41_TERMINAL_ID, true);
       	message.putISOField(cati);

       	ISOField caic=new ISOField(ISOField.F42_CARDACC_ID, "CAIC12345678901", 1, conf); // 
       	b0.setBit(ISOField.F42_CARDACC_ID, true);
       	message.putISOField(caic);
         

        ISOField actinstr=new ISOField(ISOField.F61, "Put here activation instructions", 1, conf); // 
        b0.setBit(ISOField.F61, true);
        message.putISOField(actinstr);

       	ISOField promtext=new ISOField(ISOField.F62, "Put here promotional text..", 1, conf); // 
         	b0.setBit(ISOField.F62, true);
         	message.putISOField(promtext);

		// customize field 63 to LLLVARBINARY insteda defult is LLLVARTEXT
		conf.setCustomMaxLength(ISOField.F63,1,999); 
		conf.setCustomType(ISOField.F63, 1, Type.LLLVARBINARY); 

       	ISOField field63=new ISOField(ISOField.F63, "", 1, conf); // 
       	b0.setBit(ISOField.F63, true);
			// this is now where we need special handling as to construct a fieldset
       	com.a2zss.util.BinaryString bs=new com.a2zss.util.BinaryString();
		Bitmap bitmap63_0=new Bitmap(0, conf);
		// set all needed bits first
		bitmap63_0.setBit(4, true);
		bitmap63_0.setBit(5, true);
			bitmap63_0.setBit(6, true);
			bitmap63_0.setBit(7, true);
			bitmap63_0.setBit(8, true);
			bitmap63_0.setBit(9, true);
			bitmap63_0.setBit(10, true);
			bitmap63_0.setBit(12, true);
         	bs.append(bitmap63_0.getBinaryValue()); // append bitmap data
			bs.append("                    12345".getBytes()); // 63.4 append serial number ans 25
			bs.append("0512345".getBytes()); // 63.5 append activation code
			bs.append("20031020".getBytes()); // append 63.6 expiry date subfield
			bs.append("123456789.12".getBytes() ); // append 63.7 received amount
			bs.append("978".getBytes()); // append 63.8
			bs.append("Provider name       ".getBytes()); // 63.9 append provider name
			bs.append("12".getBytes()); // 63.10 append provider indication
			bs.append("1234".getBytes()); // 63.12 append version number
			
			// set the consructed data as value of field 63
			field63.setValue(bs.getData());
            message.putISOField(field63);

         // now let lib to format message (field length padding and everything
         // like that will happen internally in ISO8583 lib)
	byte[] data=null;
	try {
          data=isosdk.formatLLPlain(message);
         
         // now you got data that could be written to tcp/ip socket outpustream
         // in this example is use System.out
         System.out.print("The formatted message='"); 
         System.out.write(data);
         System.out.println("'");
         System.out.println();
         // in case of real use: someoutputstream.write(data);
	
	} catch (Exception e) { 
			System.out.println("There was error formatting message ");
          		e.printStackTrace(System.out);
          		}
       /// now parse back to objects   
	try {
	 // create a inputstream from formatted data and parse it back to objects
	 Message message2=new Message(isosdk.parseLLPlain(new InputStreamBuffer(data)));
	 //System.out.println("Message contents: "+message2);
	 //or lets print out all fields we will find
	 for (int i=-3; i<128; i++) 
	  { ISOField isf=(ISOField)message.getISOField(i);
	    if (isf!=null) System.out.println("Found field "+i+"='"+isf.getStringValue()+"'");
	    }
	
	} catch (Exception e) { 
		System.out.println("There was error parsing message ");
		e.printStackTrace(System.out);
			}
	
	
	
	} // for n

	long end=System.currentTimeMillis();
	System.out.println(n+" cycles done in "+(end-start)+ " ms");
	
	} // main
	

} // isosample