/**
 *  Copyright AZS Services 2002-2007 http://www.a2zss.com 
 *  Iso sampe for version 2.2
 *  with LVARtext, LVarnumber
 *  */
package com.a2zss.ISO8583.samples;

import com.a2zss.ISO8583.*;

public class isosample22 {
	
	
	public static void main(String[] args) {
		testhdrfotlvar(args);
	}
	
	
	/** test a message with header, footer, lvar fields
	 * @param args
	 */
	public static void testhdrfotlvar(String[] args) {
    Config conf=new Config();
    ISO8583II isosdk=new ISO8583II(conf);
	isosdk.setOutput(System.out);
	isosdk.setDebuglevel(3);
	// libray paremeters customization for BASE24
	conf.setBitmapFormat(false); // default false=binary
	conf.setEbcdic(true);
	// define your header format and length (default none)
	conf.setCustomType(ISOField.FH_IDENT, 0, Type.TEXT);
	conf.setCustomMaxLength(ISOField.FH_IDENT,0,10); 
	
	// define custom footer field (default none)
	conf.setCustomType(ISOField.FF_FOT, 0, Type.TEXT);
	conf.setCustomMaxLength(ISOField.FF_FOT,0,10);
	
	
	// cutomize other fields needed
	conf.setCustomMaxLength(ISOField.F41_TERMINAL_ID,0,16); // default 8
	conf.setCustomMaxLength(ISOField.F52_PIN_DATA,0,16); // default 8
	conf.setCustomType(ISOField.F52_PIN_DATA,0,Type.TEXT); // default binary 8

	conf.setCustomType(ISOField.F59_TRANSPORT_DATA,0,Type.LVARTEXT); // new lvartext field
	conf.setCustomMaxLength(ISOField.F59_TRANSPORT_DATA,0,9); 
	
	conf.setCustomType(ISOField.F60,0,Type.LVARNUMBER); // new lvarnumber field
	conf.setCustomMaxLength(ISOField.F60,0,9); 
	
	
	int n=10; // number of cycles to test performance
	try { if (args!=null) n=Integer.valueOf(args[0]).intValue();
	    } catch (Exception exl) { n=10;}
	
	long start=System.currentTimeMillis();
	
	for(int j=0; j<n; j++)
	{

	// building iso message as follows:
	Message message=new Message(); // this an empty message
	
	 // the new optional header field Identifier
	 ISOField fh_ident=new ISOField(ISOField.FH_IDENT, "ML12345678", conf);
	 message.putISOField(fh_ident);
	 
	 // the new optional footer field
	 ISOField ffot=new ISOField(ISOField.FF_FOT, "MYFOOTER", conf);
	 message.putISOField(ffot);
	 
	 ISOField mti=new ISOField(ISOField.F_MTI, "0100", conf);
	 message.putISOField(mti);
	 Bitmap b0=new Bitmap(ISOField.F0_BITMAP0, conf);
	 message.putISOField(b0); // primary bitmap
	
	 Bitmap b1=new Bitmap(ISOField.F1_BITMAP1, conf);
	 b0.setBit(ISOField.F1_BITMAP1, true);
	 message.putISOField(b1); //secondary bitmap
	 
	 ISOField processing_code=new ISOField(ISOField.F3_PROC_CODE, "033000", conf);	 
         b0.setBit(ISOField.F3_PROC_CODE, true);
         message.putISOField(processing_code);
          
         ISOField amount=new ISOField(ISOField.F4_AMOUNT_TR, "250", conf);	// $2.50 
         b0.setBit(ISOField.F4_AMOUNT_TR, true);
         message.putISOField(amount);
         
         ISOField trdate=new ISOField(ISOField.F7_DATETIME_TR, "0529213059", conf); // date
         b0.setBit(ISOField.F7_DATETIME_TR, true);
         message.putISOField(trdate);
         
         ISOField stan=new ISOField(ISOField.F11_STAN, ""+j, conf); // system audit number
         b0.setBit(ISOField.F11_STAN, true);
         message.putISOField(stan);
         
         ISOField localtrtime=new ISOField(ISOField.F12_DATE_TIME_LTR, "213059", conf); // time local (21:30:59)
         b0.setBit(ISOField.F12_DATE_TIME_LTR, true);
         message.putISOField(localtrtime);
         
         ISOField localtrdate=new ISOField(ISOField.F13_DATE_EFF, "0529", conf); // date local (5/29)
         b0.setBit(ISOField.F13_DATE_EFF, true);
         message.putISOField(localtrdate);
         
         ISOField busdate=new ISOField(ISOField.F17_DATE_CAPTURE, "0530", conf); // business date (next day 5/30)
         b0.setBit(ISOField.F17_DATE_CAPTURE, true);
         message.putISOField(busdate);
         
         ISOField track2=new ISOField(ISOField.F35_TRACK2, "4443330000000012=0412000123000", conf); // track2
         b0.setBit(ISOField.F35_TRACK2, true);
         message.putISOField(track2);
         
         ISOField lcode=new ISOField(ISOField.F44_ADD_RESPDATA, "0", conf); // english
         b0.setBit(ISOField.F44_ADD_RESPDATA, true);
         message.putISOField(lcode);
         
         ISOField spdhh=new ISOField(ISOField.F48_ADD_DATA_PRIVATE, "900123456789012          010529213059FO00000000", conf); // by your spec
         b0.setBit(ISOField.F48_ADD_DATA_PRIVATE, true);
         message.putISOField(spdhh);

         // field 59 lvartext
         ISOField f59lartext=new ISOField(ISOField.F59_TRANSPORT_DATA, "xLvartext", conf); // pos cond code
         b0.setBit(ISOField.F59_TRANSPORT_DATA, true);
         message.putISOField(f59lartext);
         
         // field 60 lvarnumber testing
         ISOField poscondcode=new ISOField(ISOField.F60, "1311030", conf); // pos cond code
         b0.setBit(ISOField.F60, true);
         message.putISOField(poscondcode);

         
         ISOField cardtype=new ISOField(ISOField.F63, "C", conf); // credit card
         b0.setBit(ISOField.F63, true);
         message.putISOField(cardtype);

         ISOField optdata=new ISOField(ISOField.F127, "    MerSpec", conf); // optional data custom 
         b1.setBit(ISOField.F127, true); // this goes to second bitmap
         message.putISOField(optdata);

 
         ISOField f126=new ISOField(ISOField.F126, "ENCODING TEST: ABCDEFGHIJKLMNOPQRSTUVÕÄÖÜXYZ:abcdefghijklmnopqrstuvõäöüxyz:0123456789:!\"#¤%&/()=?@£${[]}\\*',.-_<>|", conf); // optional data custom 
         b1.setBit(ISOField.F126, true); // this goes to second bitmap
         message.putISOField(f126);
         
         ISOField f128=new ISOField(ISOField.F128, "xf128x", conf); // optional data custom 
         b1.setBit(ISOField.F128, true); // this goes to second bitmap (b1)
         message.putISOField(f128);

         
         // now let lib to format message (field length padding and everything
         // like that will happen internally in ISO8583 lib)
	byte[] data=null;
	try {
          data=isosdk.formatLLLLPlain(message);
         
         // now you got data that could be written to tcp/ip socket outpustream
         // in this example is use System.out
         System.out.print("The formatted message='"); 
         System.out.write(data);
         System.out.println("'");
         System.out.print("The formatted message HEX='"); 
         System.out.print(com.a2zss.util.Hex.toString(data));
         System.out.println("'");
         
         System.out.println();
         // in case of real use: someoutputstream.write(data);
	
	} catch (Exception e) { 
			System.out.println("There was error formatting message ");
          		e.printStackTrace(System.out);
          		}
       /// now parse back to objects   
	try {
	 // create a inputstream from formatted data and parse it back to objects
	 Message message2=isosdk.parseLLLLPlain(new InputStreamBuffer(data));
	 //System.out.println("Message contents: "+message2);
	 //or lets print out all fields we will find
	 for (int i=-4; i<=128; i++) 
	  { ISOField isf=(ISOField)message2.getISOField(i);
	    if (isf!=null) System.out.println("Found field "+i+"='"+isf.getStringValue()+"'");
	    }
	
	} catch (Exception e) { 
		System.out.println("There was error parsing message ");
		e.printStackTrace(System.out);
			}
	
	
	
	} // for n
	long end=System.currentTimeMillis();
	System.out.println(n+" cycles done in "+(end-start)+ " ms");
	
	} // main
	

} // isosample