/**
 *  Copyright AZS Services 2002-2007 http://www.a2zss.com 
 *  Iso sampe for version 2.2
 *  with LVARtext, LVarnumber
 *  */
package com.a2zss.ISO8583.samples;

import com.a2zss.ISO8583.*;

public class updatecom {
	
	
	public static void main(String[] args) {
		testhdrfotlvar(args);
	}
	
	
	/** test a message with header, footer, lvar fields
	 * @param args
	 */
	public static void testhdrfotlvar(String[] args) 
	{
    Config conf=new Config();
    ISO8583II isosdk=new ISO8583II(conf);
	isosdk.setOutput(System.out);
	isosdk.setDebuglevel(3);
	// libray paremeters customization for BASE24
	conf.setBitmapFormat(true); // default false=binary

	// define your header format and length (default none)
    conf.setCustomType(ISOField.FH_IDENT, 0, Type.TEXT); 
    conf.setCustomMaxLength(ISOField.FH_IDENT, 0, 12);  
	
	
	
	int n=1; // number of cycles to test performance
	try { if (args!=null) n=Integer.valueOf(args[0]).intValue();
	    } catch (Exception exl) { n=11;}
	
	long start=System.currentTimeMillis();
	
	String transString="ISO0060000400800822000000000000004000000000000000501200547000009001";
	
	try {
	for(int j=0; j<n; j++)
	{
   /// now parse back to objects   
	 // create a inputstream from formatted data and parse it back to objects
	 //Message message2=isosdk.parsePlain(new InputStreamBuffer(transString.getBytes()));
		Message message2=isosdk.parsePlain(new java.io.ByteArrayInputStream(transString.getBytes()));	
	 //System.out.println("Message contents: "+message2);
	 //or lets print out all fields we will find
	 for (int i=-4; i<=128; i++) 
	  { ISOField isf=(ISOField)message2.getISOField(i);
	    if (isf!=null) System.out.println("Found field "+i+"='"+isf.getStringValue()+"'");
	
	
	  } // for n
	 
	}
	
	}
	catch(Exception e)
	{ e.printStackTrace(); }
	long end=System.currentTimeMillis();
	System.out.println(n+" cycles done in "+(end-start)+ " ms");
	
	} // main
	

} // isosample